/****************************************************************************/
/* Battery Management System	                                            */
/* 2014 cermakk.cz															*/
/*																			*/
/* Module deals with the power management and battery measurements.			*/
/*																			*/
/*																			*/
/* Functions:																*/
/* ---------------															*/
/* bms_init(); Initialize this SW module									*/
/* bms_get_battery_voltage; Returns ADC value represents battery voltage	*/
/*							1bit ~ 8,86mV									*/
/****************************************************************************/

#ifndef _BMS_H_
#define _BMS_H_ 1

// Libraries
#include "mcu.h"

// Definitions
#define MAX_VOLTAGE 125
#define MIN_VOLTAGE 66



/************************************************************************/
/*                         Public functions                             */
/************************************************************************/
void bms_init(void);
/*
	initialization of battery management system
*/

uint16_t bms_get_battery_voltage(void);
/*
	returns ADC value
	1bit ~ 8,86mV
*/






/************************************************************************/
/*                               CODE                                   */
/************************************************************************/

void bms_init(void)
{
	// Ub is measured on AD pin PB0 by default. The voltage divider connected to this point consist of 100kOhm upper resistor
	// and 10kOhm lower resistor. Input voltage goes up to 40V, but by definition the lower and upper limit could be matched
	// to given battery type.
	//nastavit porty a AD prevodnik pro mereni a provest prvni mereni = zavolat funkci bms_get_bat_voltage
}



uint16_t bms_get_battery_voltage(void)
{
	//nastavit spravny kanal prevodniku
	//provest prevod a pockat na jeho dokonceni
	//vratit hodnotu zarovnanu doprava
	return 0;
}
#endif /* _BMS_H_ */