/*
 * main.c
 *
 * Created: 22.03.2017 22:54:54
 * Author : cermakk
 */ 

 #define F_CPU 2000000UL

#include <avr/io.h>
#include <util/delay.h>
#include "mcu.h"
#include "status.h"
#include "bms.h"
#include "ecc.h"
#include "remote.h"

int main(void)
{
	volatile uint16_t voltage;
	uint8_t decoded_message=0;
	volatile uint32_t encoded_message = 0;
	volatile uint32_t encoded_message_with_failure = 0;
	volatile uint8_t codeword=0;

	/* SW modules initialization */
	mcu_init();
	status_init();
	bms_init();
	remote_init();
	


	/* checking mcu SW module */
	vibrate_on();
	_delay_ms(200);
	vibrate_off();

	_delay_ms(500);
	for (uint8_t x=0;x<200;x++)
	{
		buzzer_high();
		_delay_us(800);
		buzzer_low();
		_delay_us(800);
	}
	

	/* checking status SW module */	
	status_set_green(1);
	_delay_ms(500);
	status_set_red(1);
	_delay_ms(500);
	status_set_green(0);
	status_set_red(0);


	/* checking ecc SW module */	
	codeword=0x19; // e.g. 0x19 to be encoded
	encoded_message = encode(codeword); // encode my codeword into encoded message
	encoded_message_with_failure = encoded_message^0x0101; // insert two "mistakes"
	if(decode(encoded_message_with_failure, &decoded_message)>0)	// decode the message and
	{
		// error in decoding occurred
	}


	/* checking bms SW module */
	voltage = bms_get_battery_voltage();
	if (voltage<100)	// undervoltage
	{
		// low voltage - do something
	}


	/* checking remote SW module */
	if (remote_recieve_nowait())   // checks for data continuously
	{
		for(uint8_t x=0; x<BUFFER_SIZE; x++)
		{
			if (rx_buffer[x]==67)
			{
				// do the stuff
			}
		}
	}



    /* Replace with your application code */
    while (1) 
    {
		 

		status_set_green(1);
		_delay_ms(500);
		status_set_green(0);
		_delay_ms(500);
    }
}

